using System;
using System.Collections.Generic;
using System.Text;
using System.Data;

namespace AdvancedDAtaSetManual
{
    class Program
    {
        static void Main(string[] args)
        {
             DSTovar ds = new DSTovar();

             //Manualne nastavenie primarneho kluca, 
            // pre potreby neskorsieho vyhladavania
            DataColumn[] primaryKey = new DataColumn[1];
            primaryKey[0] = ds.Vyrobca.Columns["meno"];
            ds.Vyrobca.PrimaryKey = primaryKey;
            

            //nastavenie relacii medzi tabulkami
            DataColumn parentDataColl = ds.Vyrobca.Columns["meno"];
            DataColumn childDataCol = ds.Tovar.Columns["vyrobca"]; 
            ForeignKeyConstraint FK_Vyrobca_Tovar = 
                new ForeignKeyConstraint(parentDataColl,
                                         childDataCol);
            
            FK_Vyrobca_Tovar.UpdateRule = Rule.Cascade;
            FK_Vyrobca_Tovar.DeleteRule = Rule.None;

            ds.Tovar.Constraints.Add(FK_Vyrobca_Tovar);

            
            ds.Tovar.AddTovarRow("Notebook", 5,
                ds.Vyrobca.AddVyrobcaRow("IBM", "BA")["meno"].ToString());
            ds.Tovar.AddTovarRow("Hard disk", 5,
                ds.Vyrobca.AddVyrobcaRow("WD", "Ke")["meno"].ToString());

            //vyhladanie zaznamu jedneho zaznamu
            //tentoraz potrebne pretypovanie
            DSTovar.VyrobcaRow vyrobcaIBM = (DSTovar.VyrobcaRow)
                ds.Vyrobca.Rows.Find("IBM");

            ds.Tovar.AddTovarRow("Server", 1, vyrobcaIBM["meno"].ToString());

            //Vyhladnie viacerych zaznamov
            string kriterium = "pocet = '5'"; //pozor apostrofy treba

            //Potrebne pretypovatB
            DSTovar.TovarRow[] rows =
                (DSTovar.TovarRow[])ds.Tovar.Select(kriterium);

            //Navigacia po tabulkach
            string vyrobcomJe = rows[0]["vyrobca"].ToString();
            Console.WriteLine("Vyrobcom je {0}", vyrobcomJe);

            //Pokus o vymazanie                        
            try
            {
                vyrobcaIBM.Delete();
                ds.Tovar.AcceptChanges();
            }
            catch (Exception InvalidConstraintException)
            {
                Console.WriteLine(@"Zaznam nie je mozne vymazat,
                pretoze je na neho odkazovane");
            }


            ds.WriteXml("db.txt");
            Console.ReadLine();
            
        }
    }
}
